<?PHP

/**
 * Verschlsselt einen Text mit Rijndael
 *
 * @param		string		$content			Der Text, der verschlsselt werden soll
 * @param		string		$key				Das Passwort fr die Verschlsselung
 * @param		integer		$aes				Die Verschlsselungsart
 *												128 Bit
 *												192 Bit
 *												256 Bit
 *
 * @return	mixed								Liefert im Erfolg ein Array mit den Daten						
 */

function encryptAES($content,$key,$aes)
{
	
	// Setzt den Algorithmus
	switch ($aes) 
	{
		case 128:
   		$rijndael = 'rijndael-128';
   		break;
		case 192:
   		$rijndael = 'rijndael-192';
   		break;
		default:
   		$rijndael = 'rijndael-256';
	}

	// Setzt den Verschlsselungsalgorithmus
	// und setzt den Output Feedback (OFB) Modus
	$cp = mcrypt_module_open($rijndael, '', 'ofb', '');
	if(!$cp)
		return 'Modul konnte nicht geladen werden';
	
	// Ermittelt den Initialisierungsvector, der fr die Modi CBC, CFB und OFB bentigt wird. 
	// Der Initialisierungsvector muss beim Entschlsseln den selben Wert wie beim Verschlsseln haben.
	// Windows untersttzt nur MCRYPT_RAND
	if (strtoupper(substr(PHP_OS, 0, 3)) === 'WIN')
		$enc['iv'] = mcrypt_create_iv(mcrypt_enc_get_iv_size($cp), MCRYPT_RAND);
	else
		$enc['iv'] = mcrypt_create_iv(mcrypt_enc_get_iv_size($cp), MCRYPT_DEV_RANDOM);
		
	// Ermittelt die Anzahl der Bits, welche die Schlssellnge des Keys festlegen
 	$ks = mcrypt_enc_get_key_size($cp);
  
 	// Erstellt den Schlssel, der fr die Verschlsselung genutzt wird
 	$key = substr(md5($key), 0, $ks);
  
 	// Initialisiert die Verschlsselung
 	mcrypt_generic_init($cp, $key, $enc['iv']);
  
 	// Verschlsselt die Daten
 	$enc['encrypted'] = mcrypt_generic($cp, $content);
  	
 	// Deinitialisiert die Verschlsselung 
 	mcrypt_generic_deinit($cp);
  
 	// Schliet das Modul
 	mcrypt_module_close($cp);
  
	// Erstellt einen Hash-Wert um spter prfen zu knnen, ob ein misslungene
	// Entschlsselung durchgefhrt wurde
	$enc['md5']	=	md5($content);
  
	return $enc;
	
}


/**
 * Entschlsselt einen Text mit Rijndael
 *
 * @param		string		$file					Die Datei, die entschlsselt werden soll
 * @param		string		$key					Das Passwort fr die Entschlsselung
 * @param		integer		$aes					Die Verschlsselungsart
 *													128 Bit
 *													192 Bit
 *													256 Bit
 * @param		string		$ivFile					Die Datei, mit dem IV-Tag
 *
 * @return	mixed									Liefert den entschlsselten Text, ansonsten false						
 */

function decryptAES($content,$iv, $key,$aes)
{
	
	// Setzt den Algorithmus
	switch ($aes) 
	{
		case 128:
   		$rijndael = 'rijndael-128';
   		break;
		case 192:
   		$rijndael = 'rijndael-192';
   		break;
		default:
   		$rijndael = 'rijndael-256';
	}

	// Setzt den Verschlsselungsalgorithmus
	// und setzt den Output Feedback (OFB) Modus
	$cp = mcrypt_module_open($rijndael, '', 'ofb', '');
	
	// Ermittelt die Anzahl der Bits, welche die Schlssellnge des Keys festlegen
	$ks = mcrypt_enc_get_key_size($cp);
  
	// Erstellt den Schlssel, der fr die Verschlsselung genutzt wird
	$key = substr(md5($key), 0, $ks);
  
	// Initialisiert die Verschlsselung
	mcrypt_generic_init($cp, $key, $iv);

	// Entschlsselt die Daten
	$decrypted = mdecrypt_generic($cp, $content);
  
	// Beendet die Verschlsselung 
	mcrypt_generic_deinit($cp);
  
	// Schliet das Modul
	mcrypt_module_close($cp);
  
	return trim($decrypted);
  
}

/**
 * Speichert den verschlsselten Text.
 *
 * @param		string		$encrypted		Der verschlsselte Text
 * @param		string		$iv				Der IV-Tag
 * @param		string		$infotext		Der Infotext
 * @param		integer		$aes			Die Verschlsselungsart
 *											128 Bit
 *											192 Bit
 *											256 Bit
 * @param		string		$md5			Die MD5 Prfsumme
 * @param		string		$dbTable		Tabellenname in der Datenbank
 *
 * @return		bool						Liefert true zurck						
 */
function insertBase($encrypted,$iv,$infotext,$aes,$md5,$dbTable)
{
	$encrypted = addslashes($encrypted);
	$iv = addslashes($iv);
  
	$sqlString	=	"INSERT INTO 
						$dbTable
					 SET
				 		infotext	=	'$infotext',
				 		textaes		=	'$encrypted',
				 		block			=	'$aes',
				 		encrypt		=	NOW(),
				 		ivTag			=	'$iv',
				 		md5				=	'$md5'";
	$sqlInsert	= @mysql_query($sqlString);
	
	return true;
}


/**
 * Prft die Verschlsselung anhand der MD5-Summe.
 *
 * @param		string		$decrypted		Der Text, der entschlsselt wurde
 * @param		string		$md5			Die MD5-Prfsumme vom Ursprungstext, 
 *											die beim Verschlsseln erstellt wurde
 * @param		integer		$id				Die ID des Textes in der Datenbank
 * @param		bool		$database		Handelt es sichum eine Entschlsselung
 *											oder nur eine Kontrolle.
 *											Entschlsselung: Text besteht in der Datenbank
 *											Kontrolle: Text befindet sich noch nicht in der Datenbank
 *
 * @return		mixed						Liefert einen Hinweistext oder true bzw. false						
 */
function checkDecrypt($decrypted,$md5,$id=0,$database=false)
{
	
	if($database)
	{
		if(md5($decrypted) == $md5)
		{
			$sqlUpdate	= @mysql_query("UPDATE rijndael SET decrypt = NOW() WHERE id = $id");
			$message		= "Daten konnten erfolgreich entschlsselt werden.";		
		}
		else
		{
			$sqlUpdate 	= @mysql_query("UPDATE rijndael SET decryptError = NOW() WHERE id = $id");
			$message		= "Daten konnten nicht entschlsselt werden!";
		}
	}
	else
	{
		if(md5($decrypted) == $md5)
		{
			return true;
		}
		else
		{
			return false;
		}
	}
	
	return $message;
	
}

/**
 * Bietet die IV-Datei zum Download an.
 *
 * @param		string		$iv			Der IV-Tag
 * @param		string		$md5		Die MD5-Prfsumme vom Ursprungstext, 
 *										die beim Verschlsseln erstellt wurde
 * @param		integer		$rijndael	Die Verschlsselungsart
 *										128 Bit
 *										192 Bit
 *										256 Bit
 *
 * @return		void					Liefert nichts zurck						
 */
function sendIV($iv,$md5,$rijndael)
{

	$message .= "; IV-Tag Datei\n";
	$message .= "; Erstellt am ". date("d.m.Y H:i:s") . "\n";
	$message .= "; Verschlsselung " . $rijndael . "\n";
	$message .= $iv;
	
	header("Content-Type: text");
	header("Content-Disposition: attachment; filename=\"$md5.iv\"");

	echo $message;
	
	exit;
}

/**
 * Bietet die Rijndael-Datei zum Download an.
 *
 * @param		string		$content	Der verschlsselte Text
 * @param		string		$md5		Die MD5-Prfsumme vom Ursprungstext, 
 *										die beim Verschlsseln erstellt wurde
 *
 * @return		void					Liefert nichts zurck						
 */
function sendEncrypt($content,$md5)
{

	header("Content-Type: text");
	header("Content-Disposition: attachment; filename=\"$md5.aes\"");

	echo $content;
	
	exit;
}

//$decrypted = decryptAES("aestext.txt.aes",$iv,"MeinPasswort",256);

//encryptAES($content,$password,$rijndael,$info);

?>